package com.alterdekim.game.component;

import jakarta.persistence.EntityManager;
import jakarta.transaction.Transactional;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class NativeDao {
    @Autowired
    EntityManager em;

    @Transactional
    public void updateTable(String table, String column, Boolean val, Long id) {
        String s = "UPDATE %s t SET t.%s = %b WHERE t.id = %d";
        String sql = String.format(s, table, camelToSnake(column), val, id);
        em.createNativeQuery(sql).executeUpdate();
    }

    private String camelToSnake(String str) {
        String result = "";
        char c = str.charAt(0);
        result = result + Character.toLowerCase(c);
        for (int i = 1; i < str.length(); i++) {
            char ch = str.charAt(i);
            if (Character.isUpperCase(ch)) {
                result = result + '_';
                result
                        = result
                        + Character.toLowerCase(ch);
            } else {
                result = result + ch;
            }
        }
        return result;
    }
}
